/*******************************************
 * Generates a template for PBS submission *
 * script to run geodesic-statistics.exe   *
 *                                         *
 * Abdullah Ozkanlar on 6/27/13            *
 * abdullah.ozkanlar@wsu.edu               *
 *                                         *
 *******************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#define FLN 256

int main(){

  FILE *outputf1;
  char foutput1[FLN];     

  int i, snaps, mode, path;

  printf("Enter number of snaphots:");
  scanf("%d",&snaps);

  printf("\nEnter number of the path you want:\n");
  printf("0 - for all paths\n");
  printf("2 - for dimers (1-path)\n");
  printf("3 - for trimers (2-path)\n");
  printf("4 - for tetramers (3-path)\n");
  printf("and so on...\n");
  scanf("%d",&path);

  printf("\nEnter mode:\n");
  printf("0 - statistics for the geodesic distance\n");
  printf("1 - statistics for the euclidean distance\n");
  printf("2 - lifetime of a connection\n");
  scanf("%d",&mode);

  sprintf(foutput1, "sub_geocard_%dW.pbs",path);
  outputf1=fopen(foutput1,"w");

  fprintf(outputf1,"#PBS -N statistics\n");
  fprintf(outputf1,"#PBS -l nodes=1:ppn=1\n");
  fprintf(outputf1,"#PBS -l mem=15gb\n");
  fprintf(outputf1,"#PBS -j oe\n");
  fprintf(outputf1,"cd $PBS_O_WORKDIR\n");

  fprintf(outputf1,"./geodesic-statistics.exe %d ",mode);

  for(i = 1; i <= snaps; i++){
     if(path==0) fprintf(outputf1,"graph.%dgeocard ",i);
     else fprintf(outputf1,"graph.%dgeocard-%dW ",i,path);
  }

  printf("\nSubmission: qsub sub_geocard_%dW.pbs\n",path);

  fclose(outputf1);

  return 0;
}


